jQuery(document).ready(function() { 

	// Adding Fullscreen button to toolbar
	jQuery('#ed_toolbar').append('<input type="button" class="ed_button"  id="fhe_button_fullscreen" value="fullscreen" >');

	// Creating the overlay div
	if(jQuery('#fhe-overlay').length == 0){
		jQuery(document.body).append('<div id="fhe-overlay"></div>');		
	}
	
	var $window = jQuery(window),
	$button = jQuery('#fhe_button_fullscreen'),
	$overlay = jQuery('#fhe-overlay'),
	$postdiv = jQuery('#postdiv, #postdivrich'),
	$content = jQuery('#content');
	
	$button.live('click',function(){
		if( ! $overlay.is(':visible')) {		
			fullscreen();
		} else {
			closeFullscreen();
		}
	});	
	
	function updateEditorSize(){
		$postdiv.width($window.width());
		$content.width($window.width());
		$content.height($window.height() - 90);
	}
	
	function fullscreen(){
		// Save initial value of postdiv
		$postdiv.data('height', $postdiv.height())
			.data('width', $postdiv.width())
			.data('position',$postdiv.position());
	
		$window.scrollTop(0);
		// Hide window scrollbar
		jQuery('body').addClass('fhe-noscroll');
		// Change button value
		$button.attr('value', 'close fullscreen');
		$content.addClass('fhe-noresize');
	
		$postdiv.css({
			'position':'absolute', 
			'z-index':99, 
			'left':$postdiv.data('position').left, 
			'top':$postdiv.data('position').top,
			'width':$postdiv.width()});
			
		jQuery('#normal-sortables').css('marginTop',$postdiv.height() + 40);
			
		$overlay.fadeIn('fast', function(){
			$postdiv.animate({
				'top':0,
				'left':0,
				'height': $window.height(),
				'width': $window.width()
			});
			$content.animate({
				'height': $window.height() - 90
			});
		});
		
		jQuery('#edButtonPreview').fadeOut();
		
		// Register resize window event
		$window.resize(function() {
			updateEditorSize();
		});

	}
	
	function closeFullscreen(){
		jQuery('#edButtonPreview').fadeIn();
		$postdiv.animate({
			'top':$postdiv.data('position').top,
			'left':$postdiv.data('position').left,
			'height': $postdiv.data('height'),
			'width':$postdiv.data('width')
		}, function(){
			$content.removeAttr('style');
			$overlay.fadeOut('fast', function(){
				jQuery('#normal-sortables').removeAttr('style');
				$postdiv.removeAttr('style');
	
				// Remove resize handler
				$window.unbind('resize');	
				// Restore window scrollbar
				jQuery('body').removeClass('fhe-noscroll');
				//Restore button value
				$button.attr('value', 'fullscreen');
				$content.removeClass('fhe-noresize');
			});
		});


		
	}
	
});